﻿using System;
using System.Linq;
using Microsoft.SharePoint;

namespace RH.SharePointKonferenz
{
    public class ActivationWeb : SPFeatureReceiver
    {
        public override void FeatureActivated(SPFeatureReceiverProperties properties)
        {
            CreateCountryList(properties);
        }

        public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
        {
        }

        public override void FeatureInstalled(SPFeatureReceiverProperties properties)
        {
        }

        public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
        {
        }

        private static void CreateCountryList(SPFeatureReceiverProperties properties)
        {
            try
            {
                var web = (SPWeb)properties.Feature.Parent;

                // create a new List if it does not already exist
                if (web.Lists.Cast<SPList>().Any(l => l.Title == "Countries") == false)
                {
                    // create a new list
                    web.Lists.Add("Countries", "Countries", SPListTemplateType.GenericList);
                }

                // get the list to modify it
                SPList list = web.Lists.Cast<SPList>().Where(l => l.Title == "Countries").First();

                SPFieldCollection fields = list.Fields;
                SPView view = list.DefaultView;
                // change title field
                var titleField = fields[SPBuiltInFieldId.Title];
                titleField.Required = false;
                titleField.Update();

                // add fields
                if (fields.FieldExists("Short") == false)
                {
                    // create the field, and add it to the defaultView
                    string shortName = fields.Add("Short", SPFieldType.Text, false);
                    view.ViewFields.Add(shortName);
                }

                view.Update();
                list.OnQuickLaunch = true;
                list.Update();
            }
            catch (Exception ex)
            {
                throw new SPException(string.Format("Error in CreateCountryList: {0}", ex));
            }
        }
    }
}
